<?php
  header("Content-Type: application/json; charset=UTF-8");  
  if (($_SERVER['REQUEST_METHOD'] !== 'POST') || (PHP_SAPI == 'cli')) {
    exit();
  }   
 
/* When save this file set:  Encoding => Unicode => UTF-8 - no BOM
 * Configuration for: Database Connection
 *
 * or simple use config.php file. example:  require_once("config.php");
 * 
 * DB_HOST: database host, usually it's "127.0.0.1" or "localhost", some servers also need port info
 * DB_NAME: name of the database. please note: database and database table are not the same thing
 * DB_USER: user for your database. the user needs to have rights for SELECT, UPDATE, DELETE and INSERT.
 * DB_PASS: the password of the above user
*/
  define("DB_HOST", "127.0.0.1");      // or "localhost"
  define("DB_NAME", "your_database_name");     // enter your  name of the database 
  define("DB_USER", "your_username");    // enter your mysql  user (username) for your database 
  define("DB_PASS", "your_password");      // enter your database password
  
  //   ***************************************************                
  $_POST = json_decode($_POST["x"], true);  
  $res= insert(); 
  if ($res == -1)    {          
    if (check_table() == 0)   {
       $res = create_table();     // try to create_table
       if ($res == 1)   {
         $res= insert();              // try to insert record again         
       }
       else  {
         response($res);   // error in create_table()
         exit();     
       }
    }                 
  }       
  if ($_POST["stat"] == 1)   {
    $res= google_count();
  } 
  else if ($_POST["stat"] == 2)   {
    $res= google_percent();
  }
  else if ($_POST["stat"] == 3)  {
     $res = fetch_all();
  } 
  response($res);  
  //   ***************************************************        
  
  // insert new record into wm4 table 
  function insert()   {
    validation();   // optional server basic data validation check (exclude this function if you want)
    try     {  
      $link = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);         
      if (mysqli_connect_errno()) {
          printf("Connect failed: %s\n", mysqli_connect_error());
          exit();
      }
      if (!mysqli_set_charset($link, "utf8")) {
          printf("Error loading character set utf8: %s\n", mysqli_error($link));
      } 
      $fields= "";    $values="";
      foreach ($_POST as $key=>$val)  {   
        if ($key == "stat") continue;
        $fields.= $key. ",";  
        if ( strpos($key, 'string_') === 0 ) {
           $values.=  "'". mysqli_real_escape_string($link, $val)."',";                        
        } 
        else  {
           $values.= $val.",";      // https://bugs.php.net/bug.php?id=69348
        }
      }  
      $fields =  substr($fields, 0, -1);
      $values = substr($values, 0, -1);
      $sql = "insert into wm4 (" .$fields. ") values (" .$values. ");";         
      //response($sql);   // use in debug                                                      
      if (mysqli_query($link, $sql) != TRUE || mysqli_affected_rows($link) != 1 || !mysqli_insert_id($link)) {   
        return -1;  //return mysqli_error($link);   // http://www.php.net/manual/en/mysqli.query.php
      }                                                         
      $id = mysqli_insert_id($link); 
    } 
    catch (Exception $e) {        
      return -1;  //return $e->getMessage(); 
    }            
    finally {         //  if PHP 5.5 and later
      if ($link) mysqli_close($link);
    }             
    return $id;       
  }
   
   // server response to client 
    function response($msg)  {         
      echo $msg;                     
    } 
    
    // check if wm4 table exists if insert() is failed
    function check_table()    {
      $sql= "SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = ' " . DB_NAME ." ' AND table_name = ' ".  "wm4' ";      
      try  {  
        $con = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);           
        if (mysqli_connect_errno()) {
            printf("Connect failed: %s\n", mysqli_connect_error());
            exit();
        }        
        if ($result=mysqli_query($con,$sql))  {
          $row=mysqli_fetch_row($result);
          $res= $row[0];       //$res=  mysqli_affected_rows($con) == 1  always!!;
          mysqli_free_result($result);         
        }       
      }    
      catch (Exception $e) {        
         return -1;   //return $e->getMessage(); 
      }            
      finally {         //  if PHP 5.5 and later
        if ($con) mysqli_close($con);
      }             
      return $res;   
    } 
   
   // https://www.w3resource.com/mysql/mysql-data-types.php  
    function create_table()   {       
      $sql = "create table if not exists wm4 
        (id int unsigned not null auto_increment primary key,                                    
        paradigm smallint unsigned,
        raster smallint unsigned,
        low smallint unsigned,
        high smallint unsigned, 
        within smallint unsigned,       
        item smallint unsigned,        
        timer int unsigned,
        wait smallint unsigned,        
        delay smallint unsigned,        
        correct smallint unsigned,
        incorrect smallint unsigned,   
        time_stamp timestamp default CURRENT_TIMESTAMP,              
        string_1 varchar(50),
        string_2 varchar(50),   
        string_3 varchar(50),   
        string_4 varchar(50),  
        string_5 varchar(50),        
        string_6 varchar(50), 
        string_7 varchar(50),   
        string_8 varchar(50),   
        string_9 varchar(50),  
        string_10 varchar(50),        
        int_1 int,  
        int_2 int,  
        int_3 int,        
        float_1 float,  
        float_2 float,        
        index (paradigm))                         
        engine = innodb, default character set = utf8, collate = utf8_bin;"; 
      try   {  
        $con = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);           
        if (mysqli_connect_errno()) {
            printf("Connect failed: %s\n", mysqli_connect_error());
            exit();
        }                         
        if (mysqli_query($con, $sql) != true) {
            return  mysqli_error($con); 
        }
        else  {
            return 1;     //ok 
        }
      }
      catch (Exception $e) {        
        return $e->getMessage(); 
      }            
      finally {         //  if PHP 5.5 and later
        if ($con) mysqli_close($con);
      }          
    } 
    
  //  http://stackoverflow.com/questions/17245478/building-array-and-formatting-json-for-google-charting-api  
  // Chart and Table count (prepare in google Chart/Table format)
  function google_count()   {                                    
    if (!isset($_POST["paradigm"]))  {
       return "Invalid data (paradigm field missing)";        
    }
    $sql = "select correct, count(*) as N from wm4  where paradigm=".$_POST["paradigm"]." group by 1;";      
    $con = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);           
    if (mysqli_connect_errno()) {
        printf("Connect failed: %s\n", mysqli_connect_error());
        exit();
    }         
    $result= mysqli_query($con, $sql);   // or die(mysql_error());                    
    $array['cols'][] = array('type' => 'string', 'label' =>'Correct');
    $array['cols'][] = array('type' => 'number', 'label' =>'Count');
    while ($row = mysqli_fetch_array($result)) {
       $array['rows'][] = array('c' => array( array('v'=>$row["correct"]), array('v'=>$row["N"])) );                
    }
    $cnt = mysqli_num_rows($result);  // For unbuffered result sets, mysqli_num_rows() will not return the correct number of rows until all the rows in the result have been retrieved.
    mysqli_free_result($result);
    mysqli_close($con);            
    if ($cnt > 0)  {   
      return json_encode($array, JSON_NUMERIC_CHECK);      
    }            
  }
  
  // Chart and/or Table percentage  (prepare in google Chart/Table format)            
  function google_percent()  
  {
    if (!isset($_POST["paradigm"]))  {
       return "Invalid data (paradigm field missing)";        
    }
    $sql  = "SET @total=(SELECT COUNT(*) from wm4 where paradigm=".$_POST["paradigm"].");select correct, ROUND (100*COUNT(*)/@total, 2) from wm4 where paradigm=".$_POST["paradigm"]." group by 1; ";  //order by 2 desc    
    $con = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);           
        if (mysqli_connect_errno()) {
            printf("Connect failed: %s\n", mysqli_connect_error());
            exit();
        }         
    $data = array();                                                 
    if ($con->multi_query($sql)) {
      do  {
          if ($result = $con->store_result()) {
              while ($row = $result->fetch_row()) {
                  $data[] = $row;
              }
              $result->free();
          }        
      }  while ($con->more_results() && $con->next_result());
    }            
    if (!isset($data[0][0]) || count($data) == 0)  {  
      return;     // no data @total= count(*)= 0 
    }   
    $array['cols'][] = array('type' => 'string', 'label' =>'Total of correct answers');
    $array['cols'][] = array('type' => 'number', 'label' =>'Percent');
    foreach($data as $row)
    {             
      if ( is_null($row[0]) || $row[0] == "" )  {
        $array['rows'][] = array('c' => array( array('v'=>"No answer"), array('v'=>$row[1])) );         
      }
      else  {
        $array['rows'][] = array('c' => array( array('v'=>$row[0]), array('v'=>$row[1])) );        
      }              
    }                        
    mysqli_close($con);                  
    return json_encode($array, JSON_NUMERIC_CHECK);                       
  } 
  
  // optional server basic data validation check (exclude this function if you want) 
  function validation()  {
      foreach($_POST as $key => $value)  {
        if ( strpos($key, 'string_') === 0 ) {
              $_POST[$key] = substr ($value, 0, 50);
        }  
        else if ( strpos($key, 'int_') === 0  &&  is_int($value) === false  ) {
              unset($_POST[$key]);        
        } 
        else if ( strpos($key, 'float_') === 0  && is_numeric($value) === false )   {
              unset($_POST[$key]);          
        }  
      }  
  }
   
  // fetch all wm4 table data  into array and display in html <table>
  function fetch_all()  {      
    // fetch all data data into array..
    try  {
      $con = mysqli_connect(DB_HOST, DB_USER, DB_PASS, DB_NAME);                       
        if (mysqli_connect_errno())  {
            printf("Connect failed: %s\n", mysqli_connect_error());
            exit();
        }
        if (!mysqli_set_charset($con, "utf8")) {
          printf("Error loading character set utf8: %s\n", mysqli_error($con));
        }                                          
        $sql= "select * from wm4 order by id desc";
        $result = mysqli_query($con, $sql);  
         //if (!$result) printf("Errormessage: %s\n", mysqli_error($con));                                                        
        $data = array();
        while ($row = mysqli_fetch_assoc($result)) { 
          $data[] = $row; 
        } 
        $cnt= mysqli_num_rows($result);
      }
      finally  {
        mysqli_free_result($result);                                            
      }
      if ($cnt == 0)  {   
        return "<p>No data</p>";                                                               
      }   
      // echo html table from 2dim array..
      $colNames = array_keys(reset($data)); 
      $res=  '<div><table class="db_table"><tr>';     
      foreach($colNames as $colName)  {
        $res.= "<th>$colName</th>";
      }               
      $res.= "</tr>";            
      foreach($data as $row)
      {
        $res.= '<tr>';
        foreach($colNames as $colName)  {
           $res.= '<td>'.$row[$colName]."</td>";
        } 
        $res.= "</tr>";
      }       
      $res.= "</table></div>";                   
      return $res;
  }
           
?>